/* original parser id follows */
/* yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93" */
/* (use YYMAJOR/YYMINOR for ifdefs dependent on parser version) */

#define YYBYACC 1
#define YYMAJOR 2
#define YYMINOR 0
#define YYPATCH 20230521

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)
#define YYENOMEM       (-2)
#define YYEOF          0
#undef YYBTYACC
#define YYBTYACC 0
#define YYDEBUGSTR YYPREFIX "debug"

#ifndef yyparse
#define yyparse    xo_xpath_yyparse
#endif /* yyparse */

#ifndef yylex
#define yylex      xo_xpath_yylex
#endif /* yylex */

#ifndef yyerror
#define yyerror    xo_xpath_yyerror
#endif /* yyerror */

#ifndef yychar
#define yychar     xo_xpath_yychar
#endif /* yychar */

#ifndef yyval
#define yyval      xo_xpath_yyval
#endif /* yyval */

#ifndef yylval
#define yylval     xo_xpath_yylval
#endif /* yylval */

#ifndef yydebug
#define yydebug    xo_xpath_yydebug
#endif /* yydebug */

#ifndef yynerrs
#define yynerrs    xo_xpath_yynerrs
#endif /* yynerrs */

#ifndef yyerrflag
#define yyerrflag  xo_xpath_yyerrflag
#endif /* yyerrflag */

#ifndef yylhs
#define yylhs      xo_xpath_yylhs
#endif /* yylhs */

#ifndef yylen
#define yylen      xo_xpath_yylen
#endif /* yylen */

#ifndef yydefred
#define yydefred   xo_xpath_yydefred
#endif /* yydefred */

#ifndef yystos
#define yystos     xo_xpath_yystos
#endif /* yystos */

#ifndef yydgoto
#define yydgoto    xo_xpath_yydgoto
#endif /* yydgoto */

#ifndef yysindex
#define yysindex   xo_xpath_yysindex
#endif /* yysindex */

#ifndef yyrindex
#define yyrindex   xo_xpath_yyrindex
#endif /* yyrindex */

#ifndef yygindex
#define yygindex   xo_xpath_yygindex
#endif /* yygindex */

#ifndef yytable
#define yytable    xo_xpath_yytable
#endif /* yytable */

#ifndef yycheck
#define yycheck    xo_xpath_yycheck
#endif /* yycheck */

#ifndef yyname
#define yyname     xo_xpath_yyname
#endif /* yyname */

#ifndef yyrule
#define yyrule     xo_xpath_yyrule
#endif /* yyrule */

#if YYBTYACC

#ifndef yycindex
#define yycindex   xo_xpath_yycindex
#endif /* yycindex */

#ifndef yyctable
#define yyctable   xo_xpath_yyctable
#endif /* yyctable */

#endif /* YYBTYACC */

#define YYPREFIX "xo_xpath_yy"

#define YYPURE 1

#line 2 "../../libxo/xo_xpath.y"
/*
 * Copyright (c) 2006-2023, Juniper Networks, Inc.
 * All rights reserved.
 * This SOFTWARE is licensed under the LICENSE provided in the
 * ../Copyright file. By downloading, installing, copying, or otherwise
 * using the SOFTWARE, you agree to be bound by the terms of that
 * LICENSE.
 * Phil Shafer, July 2023 (based on libslax's slaxparser.y)
 *
 * This is an implementation of XPath, suitable for filtering libxo nodes.
 * I'm hoping for something small and efficient.....
 */
#line 17 "../../libxo/xo_xpath.y"
#line 144 "../../libxo/xo_xpath.y"

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <unistd.h>
#include <stddef.h>
#include <wchar.h>
#include <locale.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/param.h>
#include <stdarg.h>
#include <string.h>
#include <errno.h>
#include <limits.h>
#include <ctype.h>
#include <wctype.h>
#include <getopt.h>

#include "xo_config.h"
#include "xo.h"
#include "xo_encoder.h"
#include "xo_buf.h"
#include "xo_xpath.tab.h"
#include "xo_xparse.h"

/*
 * This is a pure parser, allowing this library to link with other users
 * of yacc. To allow this, we pass our data structure (xpath_data_t)
 * to yyparse as the argument.
 */
#define yyparse xo_xpath_yyparse
#define YYPARSE_PARAM_TYPE xo_xparse_data_t *
#define YYPARSE_PARAM xparse_data
#define YYLEX_PARAM_TYPE xo_xparse_data_t *
#define YYLEX_PARAM xparse_data

#define YYSTYPE xo_xparse_node_id_t

#define YYERROR_VERBOSE

/*
 * To save space, we use our own YYINT instead of the standard "int"
 * definition.  Sadly, this isn't an easy replacement, so we use
 * "SED_OPTS" in Makefile.am to remove the original typedef.
 */
#define YYINT int16_t

/*
 * With a "pure" parser, these are all local variables so we don't
 * need to have them #defined into "long" version (with the prefix),
 * so we nuke the #defines and use the real/old names.
 */
#undef yyerrflag
#undef yychar
#undef yyval
#undef yylval
#undef yynerrs
#undef yyloc
#undef yylloc

#undef yyerror
#define yyerror(_str) \
    xo_xpath_yyerror(xparse_data, _str, yystate)

#undef yylex
#define yylex(_lvalp, _param) \
    xo_xpath_yylex(_param, _lvalp)

#define yytname xo_xpath_yyname
#define yypact xo_xpath_yydefred
#define yydebug xo_xpath_yydebug

/*
 * Even if we don't want debug printfs, we still need the arrays with
 * names for our own nefarious purposes.
 */
#undef YYDEBUG
#ifdef XO_YYDEBUG
#define YYDEBUG 1		/* Enable debug output */
/* Log via our function */
#define YYFPRINTF(_fp, _fmt...) xo_xparse_yyprintf(xparse_data, _fmt)
#else /* XO_YYDEBUG */
#define YYDEBUG 1		/* Needed for yytname[] */
#define YYFPRINTF xo_dont_bother /* Don't log via our function */
#define fprintf xo_dont_bother
#define getenv(_x) NULL		/* Don't let it fetch "YYDEBUG" */

static inline void UNUSED
xo_dont_bother (FILE *fp UNUSED, const char *fmt UNUSED, ...)
{
    return;
}

#endif /* XO_YYDEBUG */

#line 232 "xo_xpath.tab.c"

#if ! defined(YYSTYPE) && ! defined(YYSTYPE_IS_DECLARED)
/* Default: YYSTYPE is the semantic value type. */
typedef int YYSTYPE;
# define YYSTYPE_IS_DECLARED 1
#endif

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# ifdef YYLEX_PARAM_TYPE
#  define YYLEX_DECL() yylex(YYSTYPE *yylval, YYLEX_PARAM_TYPE YYLEX_PARAM)
# else
#  define YYLEX_DECL() yylex(YYSTYPE *yylval, void * YYLEX_PARAM)
# endif
# define YYLEX yylex(&yylval, YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(YYSTYPE *yylval)
# define YYLEX yylex(&yylval)
#endif

/* Parameters sent to yyerror. */
#ifndef YYERROR_DECL
#define YYERROR_DECL() yyerror(const char *s)
#endif
#ifndef YYERROR_CALL
#define YYERROR_CALL(msg) yyerror(msg)
#endif


#define L_ASSIGN 1
#define L_AT 2
#define L_CBRACE 3
#define L_COMMA 4
#define L_COLON 5
#define L_DAMPER 6
#define L_DCOLON 7
#define L_DEQUALS 8
#define L_DOTDOT 9
#define L_DOTDOTDOT 10
#define L_DSLASH 11
#define L_DVBAR 12
#define L_EOS 13
#define L_EQUALS 14
#define L_GRTR 15
#define L_GRTREQ 16
#define L_LESS 17
#define L_LESSEQ 18
#define L_MINUS 19
#define L_NOT 20
#define L_NOTEQUALS 21
#define L_OBRACE 22
#define L_OBRACK 23
#define L_OPAREN 24
#define L_PLUS 25
#define L_PLUSEQUALS 26
#define L_QUESTION 27
#define L_SLASH 28
#define L_STAR 29
#define L_UNDERSCORE 30
#define L_VBAR 31
#define L_LAST 32
#define K_COMMENT 33
#define K_ID 34
#define K_KEY 35
#define K_NODE 36
#define K_PROCESSING_INSTRUCTION 37
#define K_TEXT 38
#define M_OPERATOR_FIRST 39
#define K_AND 40
#define K_DIV 41
#define K_MOD 42
#define K_OR 43
#define M_OPERATOR_LAST 44
#define M_MULTIPLICATION_TEST_LAST 45
#define L_ASTERISK 46
#define L_CBRACK 47
#define L_CPAREN 48
#define L_DOT 49
#define T_AXIS_NAME 50
#define T_BARE 51
#define T_FUNCTION_NAME 52
#define T_NUMBER 53
#define T_QUOTED 54
#define T_VAR 55
#define M_SEQUENCE 56
#define M_CONCAT 57
#define M_TERNARY 58
#define M_TERNARY_END 59
#define M_ERROR 60
#define M_XPATH 61
#define M_PARSE_FULL 62
#define M_PARSE_SLAX 63
#define M_PARSE_XPATH 64
#define M_PARSE_PARTIAL 65
#define M_JSON 66
#define C_ABSOLUTE 67
#define C_ATTRIBUTE 68
#define C_DESCENDANT 69
#define C_ELEMENT 70
#define C_EXPR 71
#define C_INDEX 72
#define C_NOT 73
#define C_PATH 74
#define C_PREDICATE 75
#define C_TEST 76
#define C_UNION 77
#define C_INT64 78
#define C_UINT64 79
#define C_FLOAT 80
#define C_STRING 81
#define C_BOOLEAN 82
#define YYERRCODE 256
static const YYINT xo_xpath_yylhs[] = {                  -1,
    0,    2,    3,    4,    1,    7,    7,    8,    8,    9,
    9,   10,   10,   12,   12,    5,   15,   15,   15,   17,
   17,   17,   17,   17,    6,    6,   23,   23,   24,   24,
   24,   24,   25,   25,   16,   16,   27,   27,   28,   28,
   28,   30,   30,   31,   31,   31,   32,   32,   32,   32,
   33,   33,   13,   13,   22,   34,   34,   35,   35,   36,
   37,   37,   37,   39,   39,   26,   11,   11,   11,   40,
   40,   14,   41,   20,   44,   44,   21,   19,   42,   42,
   42,   45,   45,   46,   46,   46,   43,   43,   38,   18,
   29,   29,   29,   29,   29,
};
static const YYINT xo_xpath_yylen[] = {                   2,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    2,    1,    1,    1,    5,    4,    3,
    1,    1,    1,    1,    1,    3,    1,    2,    1,    1,
    3,    3,    1,    2,    1,    3,    1,    3,    1,    3,
    3,    1,    3,    1,    3,    3,    1,    3,    3,    3,
    1,    2,    0,    1,    4,    0,    1,    1,    3,    1,
    0,    2,    1,    0,    2,    3,    1,    3,    1,    3,
    1,    2,    3,    1,    0,    1,    1,    1,    1,    3,
    4,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    3,    3,    3,    3,
};
static const YYINT xo_xpath_yydefred[] = {                0,
   89,   88,    0,    0,    0,    0,   87,    0,    0,   77,
   74,   78,    0,    1,    0,   29,    0,   13,   15,   33,
   21,   22,   23,   24,   25,   27,    0,    0,   63,   67,
   69,   71,    0,   28,    0,   90,    0,   16,    0,    0,
    0,    0,    0,    0,    0,    0,   47,    0,   14,   62,
    0,    0,    0,    0,    0,    0,    0,   34,   84,   86,
    0,   85,   83,    2,   82,   64,   79,    0,   52,    9,
    0,    8,    0,   20,    7,    6,    0,   11,   10,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   60,    3,    4,    0,    0,   58,   26,   73,   68,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   48,
   49,   50,   55,    0,   66,   76,    0,   65,   80,   19,
    0,   59,   81,   18,
};
#if defined(YYDESTRUCT_CALL) || defined(YYSTYPE_TOSTRING)
static const YYINT xo_xpath_yystos[] = {                  0,
    2,    9,   11,   20,   24,   28,   49,   50,   52,   53,
   54,   55,  280,  281,  286,  290,  291,  292,  294,  297,
  299,  300,  301,  302,  303,  304,  305,  317,  318,  320,
  321,  323,  291,  304,   19,  285,  286,  295,  296,  298,
  307,  308,  309,  310,  311,  312,  313,  291,  293,    7,
   24,   31,   11,   28,   11,   23,   28,  306,   33,   36,
   37,   38,   46,   51,  282,  322,  325,  326,  313,   12,
   27,   43,  288,   48,    6,   40,  287,    8,   14,   21,
  289,   15,   16,   17,   18,   30,   19,   25,   29,   41,
   42,  283,  284,  285,  314,  315,  316,  303,  320,  320,
  291,  284,  291,   24,  319,   24,    5,  296,  307,  308,
  309,  309,  310,  310,  310,  310,  311,  312,  312,  313,
  313,  313,   48,    4,   47,  300,  324,  306,   48,  295,
    5,  316,   48,  295,
};
#endif /* YYDESTRUCT_CALL || YYSTYPE_TOSTRING */
static const YYINT xo_xpath_yydgoto[] = {                13,
   14,   65,   92,   93,   94,   37,   77,   73,   81,   16,
   17,   18,   49,   19,   38,   39,   20,   40,   21,   22,
   23,   24,   25,   26,   27,   58,   41,   42,   43,   44,
   45,   46,   47,   95,   96,   97,   28,   29,  105,   30,
   31,   66,   32,  127,   67,   68,
};
static const YYINT xo_xpath_yysindex[] = {               60,
    0,    0,   36,   72,   23,   36,    0,   12,  -17,    0,
    0,    0,    0,    0,   -5,    0,  -10,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    1,  532,    0,    0,
    0,    0,  -10,    0,   23,    0,   -5,    0,   -6,  -25,
   -4,   19,  194,   16,   -8,   76,    0,  -10,    0,    0,
   23,   60,   36,   36,   36,   23,   36,    0,    0,    0,
   20,    0,    0,    0,    0,    0,    0,   26,    0,    0,
   11,    0,   23,    0,    0,    0,   23,    0,    0,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,    0,    0,    0,   10,   66,    0,    0,    0,    0,
  -10,   32,  -10,   28,   64,   42,   23,   -2,   -4,   19,
  194,  194,   16,   16,   16,   16,   -8,   76,   76,    0,
    0,    0,    0,   23,    0,    0,   43,    0,    0,    0,
   23,    0,    0,    0,
};
static const YYINT xo_xpath_yyrindex[] = {              577,
    0,    0,  577,  577,  577,  128,    0,    0,    0,    0,
    0,    0,    0,    0,   95,    0,  222,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  267,    0,    0,    0,
    0,    0,  312,    0,  577,    0,  492,    0,    5,    0,
  969,  963,  906,  762,  672,  537,    0,  357,    0,    0,
   56,  577,  577,  577,  577,  577,  577,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  577,    0,  577,    0,    0,    0,  577,    0,    0,  577,
  577,  577,  577,  577,  577,  577,  577,  577,  577,  577,
  577,    0,    0,    0,    0,   49,    0,    0,    0,    0,
  402,    0,  447,   50,  177,    0,  577,    0,  987,  981,
  918,  936,  780,  825,  843,  888,  717,  582,  627,    0,
    0,    0,    0,  577,    0,    0,    0,    0,    0,    0,
  577,    0,    0,    0,
};
#if YYBTYACC
static const YYINT xo_xpath_yycindex[] = {                0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,
};
#endif
static const YYINT xo_xpath_yygindex[] = {                0,
    0,    0,    0,   45,   94,  103,    0,    0,    0,    0,
    2,    0,    0,    0, -103,   35,    0,    0,    0,    4,
    0,    0,   59,  112,    0,   15,   46,   52,  -66,  131,
   37,  -39,  -35,    0,    0,    6,    0,    0,    0,   14,
    0,    0,    0,    0,    0,    0,
};
#define YYTABLESIZE 1035
static const YYINT xo_xpath_yytable[] = {                69,
   53,   75,  131,  130,   33,   70,   51,   48,   17,   70,
   87,   55,    1,  111,  112,  107,   88,   54,   50,    2,
   71,    3,   74,   56,    1,   52,   78,  134,   57,   35,
    4,    2,   79,    3,    5,   76,   72,    1,    6,   80,
   72,   35,    4,  104,    2,   86,    5,  118,  119,  106,
    6,   17,   17,  120,  121,  122,  101,  123,  103,    7,
    8,    1,    9,   10,   11,   12,   99,  100,    2,  124,
    3,    7,    8,    1,    9,   10,   11,   12,  125,    4,
    2,   11,    3,    5,    7,    8,   56,    6,   61,  129,
  133,   61,   61,   61,    5,    5,   57,   75,   36,    6,
  102,   61,   15,   56,   89,  108,   61,  126,    7,    8,
   98,    9,   10,   11,   12,   34,   90,   91,  109,  128,
    7,    8,  117,    9,   10,   11,   12,   53,  110,  132,
    0,   53,   53,   53,    0,   53,    0,    0,    0,   53,
    0,   53,   53,   53,   53,   53,   53,    0,   53,    0,
    0,    0,   53,    0,   53,    0,   53,   53,   53,    0,
   61,    0,    0,   61,   61,   61,    0,   53,   53,   53,
   53,    0,    0,   61,   53,   53,   70,    0,   61,    0,
   70,   70,   70,    0,   70,    0,    0,   70,   70,    0,
   70,   70,   70,   70,   70,   70,    0,   70,    0,    0,
    0,   70,    0,   70,   70,   70,   70,   70,   82,   83,
   84,   85,  113,  114,  115,  116,   70,   70,   70,   70,
    0,   12,    0,   70,   70,   12,   12,   12,    0,   12,
    0,    0,    0,   12,    0,   12,   12,   12,   12,   12,
   12,    0,   12,    0,    0,    0,   12,    0,   12,    0,
   12,   12,   12,    0,    0,    0,    0,    0,    0,    0,
    0,   12,   12,   12,   12,    0,   30,    0,   12,   12,
   30,   30,   30,    0,   30,    0,    0,    0,   30,    0,
   30,   30,   30,   30,   30,   30,    0,   30,    0,    0,
    0,   30,    0,   30,    0,   30,   30,   30,    0,    0,
    0,    0,    0,    0,    0,    0,   30,   30,   30,   30,
    0,   72,    0,   30,   30,   72,   72,   72,    0,   72,
    0,    0,    0,   72,    0,   72,   72,   72,   72,   72,
   72,    0,   72,    0,    0,    0,   72,    0,   72,    0,
   72,   72,   72,    0,    0,    0,    0,    0,    0,    0,
    0,   72,   72,   72,   72,    0,   54,    0,   72,   72,
   54,   54,   54,    0,   54,    0,    0,    0,   54,    0,
   54,   54,   54,   54,   54,   54,    0,   54,    0,    0,
    0,   54,    0,   54,    0,   54,   54,   54,    0,    0,
    0,    0,    0,    0,    0,    0,   54,   54,   54,   54,
    0,   32,    0,   54,   54,   32,   32,   32,    0,   32,
    0,    0,    0,   32,    0,   32,   32,   32,   32,   32,
   32,    0,   32,    0,    0,    0,   32,    0,   32,    0,
   32,   32,   32,    0,    0,    0,    0,    0,    0,    0,
    0,   32,   32,   32,   32,    0,   31,    0,   32,   32,
   31,   31,   31,    0,   31,    0,    0,    0,   31,    0,
   31,   31,   31,   31,   31,   31,    0,   31,    0,    0,
    0,   31,    0,   31,    0,   31,   31,   31,    0,    0,
    0,    0,    0,    0,    0,    0,   31,   31,   31,   31,
    0,    0,    0,   31,   31,   51,   51,   51,    0,   51,
    0,    0,    0,   51,    0,   51,   51,   51,   51,   51,
   51,    0,   51,    0,    0,    0,   51,    0,   51,    0,
   51,   51,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   51,   51,   51,   51,    0,    0,    0,   51,   51,
   44,   44,   44,    0,   44,    0,    0,    0,   44,    0,
   44,   44,   44,   44,   44,   44,    0,   44,    0,    0,
    0,   44,    0,   44,   59,    0,   44,   60,   61,   62,
    0,    0,    0,    0,    0,    0,   44,   63,    0,   44,
    0,    0,   64,   44,   44,   46,   46,   46,    0,   46,
    0,    0,    0,   46,    0,   46,   46,   46,   46,   46,
   46,    0,   46,    0,    0,    0,   46,    0,   46,   61,
    0,   46,   61,   61,   61,    0,    0,    0,    0,    0,
    0,   46,   61,    0,   46,    0,    0,   61,   46,   46,
   45,   45,   45,    0,   45,    0,    0,    0,   45,    0,
   45,   45,   45,   45,   45,   45,    0,   45,    0,    0,
    0,   45,    0,   45,    0,    0,   45,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   45,    0,    0,   45,
    0,    0,    0,   45,   45,   42,   42,   42,    0,   42,
    0,    0,    0,   42,    0,   42,   42,   42,   42,   42,
    0,    0,   42,    0,    0,    0,    0,    0,   42,    0,
    0,   42,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   42,    0,    0,   42,    0,    0,    0,   42,   42,
   43,   43,   43,    0,   43,    0,    0,    0,   43,    0,
   43,   43,   43,   43,   43,    0,    0,   43,    0,    0,
    0,    0,    0,   43,    0,    0,   43,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   43,    0,    0,   43,
    0,    0,    0,   43,   43,   91,   91,   91,    0,   91,
    0,    0,    0,   91,    0,   91,   91,   91,   91,   91,
    0,    0,   91,   93,   93,   93,    0,   93,   91,    0,
    0,   93,    0,   93,   93,   93,   93,   93,    0,    0,
   93,   91,    0,    0,   91,    0,   93,    0,   91,   91,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   93,
    0,    0,   93,    0,    0,    0,   93,   93,   95,   95,
   95,    0,   95,    0,    0,    0,   95,    0,   95,   95,
   95,   95,   95,    0,    0,   95,   92,   92,   92,    0,
   92,   95,    0,    0,   92,    0,   92,   92,   92,   92,
   92,    0,    0,   92,   95,    0,    0,   95,    0,   92,
    0,   95,   95,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   92,    0,    0,   92,    0,    0,    0,   92,
   92,   94,   94,   94,    0,   94,    0,    0,    0,   94,
    0,   94,   94,   94,   94,   94,    0,    0,   94,   39,
   39,   39,    0,   39,   94,    0,    0,   39,    0,   39,
    0,   41,   41,   41,    0,   41,   39,   94,    0,   41,
   94,   41,   39,    0,   94,   94,    0,    0,   41,   40,
   40,   40,    0,   40,   41,   39,    0,   40,   39,   40,
    0,    0,   39,   39,    0,    0,   40,   41,    0,    0,
   41,    0,   40,    0,   41,   41,   37,   37,   37,    0,
    0,    0,   35,   35,   37,   40,    0,    0,   40,    0,
   35,    0,   40,   40,   38,   38,   38,    0,    0,   37,
   36,   36,   38,    0,    0,   35,    0,    0,   36,    0,
    0,    0,   37,    0,    0,   37,    0,   38,    0,   37,
   37,   35,    0,   36,    0,   35,   35,    0,    0,    0,
   38,    0,    0,   38,    0,    0,    0,   38,   38,   36,
    0,    0,    0,   36,   36,
};
static const YYINT xo_xpath_yycheck[] = {                35,
   11,    6,    5,  107,    3,   12,   24,    6,    4,   12,
   19,   11,    2,   80,   81,    5,   25,   28,    7,    9,
   27,   11,   48,   23,    2,   31,    8,  131,   28,   19,
   20,    9,   14,   11,   24,   40,   43,    2,   28,   21,
   43,   19,   20,   24,    9,   30,   24,   87,   88,   24,
   28,   47,   48,   89,   90,   91,   55,   48,   57,   49,
   50,    2,   52,   53,   54,   55,   53,   54,    9,    4,
   11,   49,   50,    2,   52,   53,   54,   55,   47,   20,
    9,   54,   11,   24,   49,   50,   23,   28,   33,   48,
   48,   36,   37,   38,    0,   24,   48,   48,    5,   28,
   56,   46,    0,   48,   29,   71,   51,  104,   49,   50,
   52,   52,   53,   54,   55,    4,   41,   42,   73,  105,
   49,   50,   86,   52,   53,   54,   55,    0,   77,  124,
   -1,    4,    5,    6,   -1,    8,   -1,   -1,   -1,   12,
   -1,   14,   15,   16,   17,   18,   19,   -1,   21,   -1,
   -1,   -1,   25,   -1,   27,   -1,   29,   30,   31,   -1,
   33,   -1,   -1,   36,   37,   38,   -1,   40,   41,   42,
   43,   -1,   -1,   46,   47,   48,    0,   -1,   51,   -1,
    4,    5,    6,   -1,    8,   -1,   -1,   11,   12,   -1,
   14,   15,   16,   17,   18,   19,   -1,   21,   -1,   -1,
   -1,   25,   -1,   27,   28,   29,   30,   31,   15,   16,
   17,   18,   82,   83,   84,   85,   40,   41,   42,   43,
   -1,    0,   -1,   47,   48,    4,    5,    6,   -1,    8,
   -1,   -1,   -1,   12,   -1,   14,   15,   16,   17,   18,
   19,   -1,   21,   -1,   -1,   -1,   25,   -1,   27,   -1,
   29,   30,   31,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   40,   41,   42,   43,   -1,    0,   -1,   47,   48,
    4,    5,    6,   -1,    8,   -1,   -1,   -1,   12,   -1,
   14,   15,   16,   17,   18,   19,   -1,   21,   -1,   -1,
   -1,   25,   -1,   27,   -1,   29,   30,   31,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   40,   41,   42,   43,
   -1,    0,   -1,   47,   48,    4,    5,    6,   -1,    8,
   -1,   -1,   -1,   12,   -1,   14,   15,   16,   17,   18,
   19,   -1,   21,   -1,   -1,   -1,   25,   -1,   27,   -1,
   29,   30,   31,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   40,   41,   42,   43,   -1,    0,   -1,   47,   48,
    4,    5,    6,   -1,    8,   -1,   -1,   -1,   12,   -1,
   14,   15,   16,   17,   18,   19,   -1,   21,   -1,   -1,
   -1,   25,   -1,   27,   -1,   29,   30,   31,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   40,   41,   42,   43,
   -1,    0,   -1,   47,   48,    4,    5,    6,   -1,    8,
   -1,   -1,   -1,   12,   -1,   14,   15,   16,   17,   18,
   19,   -1,   21,   -1,   -1,   -1,   25,   -1,   27,   -1,
   29,   30,   31,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   40,   41,   42,   43,   -1,    0,   -1,   47,   48,
    4,    5,    6,   -1,    8,   -1,   -1,   -1,   12,   -1,
   14,   15,   16,   17,   18,   19,   -1,   21,   -1,   -1,
   -1,   25,   -1,   27,   -1,   29,   30,   31,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   40,   41,   42,   43,
   -1,   -1,   -1,   47,   48,    4,    5,    6,   -1,    8,
   -1,   -1,   -1,   12,   -1,   14,   15,   16,   17,   18,
   19,   -1,   21,   -1,   -1,   -1,   25,   -1,   27,   -1,
   29,   30,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   40,   41,   42,   43,   -1,   -1,   -1,   47,   48,
    4,    5,    6,   -1,    8,   -1,   -1,   -1,   12,   -1,
   14,   15,   16,   17,   18,   19,   -1,   21,   -1,   -1,
   -1,   25,   -1,   27,   33,   -1,   30,   36,   37,   38,
   -1,   -1,   -1,   -1,   -1,   -1,   40,   46,   -1,   43,
   -1,   -1,   51,   47,   48,    4,    5,    6,   -1,    8,
   -1,   -1,   -1,   12,   -1,   14,   15,   16,   17,   18,
   19,   -1,   21,   -1,   -1,   -1,   25,   -1,   27,   33,
   -1,   30,   36,   37,   38,   -1,   -1,   -1,   -1,   -1,
   -1,   40,   46,   -1,   43,   -1,   -1,   51,   47,   48,
    4,    5,    6,   -1,    8,   -1,   -1,   -1,   12,   -1,
   14,   15,   16,   17,   18,   19,   -1,   21,   -1,   -1,
   -1,   25,   -1,   27,   -1,   -1,   30,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,   43,
   -1,   -1,   -1,   47,   48,    4,    5,    6,   -1,    8,
   -1,   -1,   -1,   12,   -1,   14,   15,   16,   17,   18,
   -1,   -1,   21,   -1,   -1,   -1,   -1,   -1,   27,   -1,
   -1,   30,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   40,   -1,   -1,   43,   -1,   -1,   -1,   47,   48,
    4,    5,    6,   -1,    8,   -1,   -1,   -1,   12,   -1,
   14,   15,   16,   17,   18,   -1,   -1,   21,   -1,   -1,
   -1,   -1,   -1,   27,   -1,   -1,   30,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,   43,
   -1,   -1,   -1,   47,   48,    4,    5,    6,   -1,    8,
   -1,   -1,   -1,   12,   -1,   14,   15,   16,   17,   18,
   -1,   -1,   21,    4,    5,    6,   -1,    8,   27,   -1,
   -1,   12,   -1,   14,   15,   16,   17,   18,   -1,   -1,
   21,   40,   -1,   -1,   43,   -1,   27,   -1,   47,   48,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,
   -1,   -1,   43,   -1,   -1,   -1,   47,   48,    4,    5,
    6,   -1,    8,   -1,   -1,   -1,   12,   -1,   14,   15,
   16,   17,   18,   -1,   -1,   21,    4,    5,    6,   -1,
    8,   27,   -1,   -1,   12,   -1,   14,   15,   16,   17,
   18,   -1,   -1,   21,   40,   -1,   -1,   43,   -1,   27,
   -1,   47,   48,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   40,   -1,   -1,   43,   -1,   -1,   -1,   47,
   48,    4,    5,    6,   -1,    8,   -1,   -1,   -1,   12,
   -1,   14,   15,   16,   17,   18,   -1,   -1,   21,    4,
    5,    6,   -1,    8,   27,   -1,   -1,   12,   -1,   14,
   -1,    4,    5,    6,   -1,    8,   21,   40,   -1,   12,
   43,   14,   27,   -1,   47,   48,   -1,   -1,   21,    4,
    5,    6,   -1,    8,   27,   40,   -1,   12,   43,   14,
   -1,   -1,   47,   48,   -1,   -1,   21,   40,   -1,   -1,
   43,   -1,   27,   -1,   47,   48,    4,    5,    6,   -1,
   -1,   -1,    4,    5,   12,   40,   -1,   -1,   43,   -1,
   12,   -1,   47,   48,    4,    5,    6,   -1,   -1,   27,
    4,    5,   12,   -1,   -1,   27,   -1,   -1,   12,   -1,
   -1,   -1,   40,   -1,   -1,   43,   -1,   27,   -1,   47,
   48,   43,   -1,   27,   -1,   47,   48,   -1,   -1,   -1,
   40,   -1,   -1,   43,   -1,   -1,   -1,   47,   48,   43,
   -1,   -1,   -1,   47,   48,
};
#if YYBTYACC
static const YYINT xo_xpath_yyctable[] = {               -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,
};
#endif
#define YYFINAL 13
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 278
#define YYUNDFTOKEN 327
#define YYTRANSLATE(a) ((a) > YYMAXTOKEN ? YYUNDFTOKEN : (a))
#if YYDEBUG
static const char *const xo_xpath_yyname[] = {

"$end","L_ASSIGN","L_AT","L_CBRACE","L_COMMA","L_COLON","L_DAMPER","L_DCOLON",
"L_DEQUALS","L_DOTDOT","L_DOTDOTDOT","L_DSLASH","L_DVBAR","L_EOS","L_EQUALS",
"L_GRTR","L_GRTREQ","L_LESS","L_LESSEQ","L_MINUS","L_NOT","L_NOTEQUALS",
"L_OBRACE","L_OBRACK","L_OPAREN","L_PLUS","L_PLUSEQUALS","L_QUESTION","L_SLASH",
"L_STAR","L_UNDERSCORE","L_VBAR","L_LAST","'!'","K_ID","K_KEY","K_NODE",
"K_PROCESSING_INSTRUCTION","K_TEXT","M_OPERATOR_FIRST","'('","K_DIV","'*'",
"'+'","','","'-'","L_ASTERISK","'/'","L_CPAREN","L_DOT","T_AXIS_NAME","T_BARE",
"T_FUNCTION_NAME","T_NUMBER","T_QUOTED","T_VAR","M_SEQUENCE","M_CONCAT","':'",
"';'","'<'","'='","'>'","'?'","'@'","M_PARSE_PARTIAL","M_JSON","C_ABSOLUTE",
"C_ATTRIBUTE","C_DESCENDANT","C_ELEMENT","C_EXPR","C_INDEX","C_NOT","C_PATH",
"C_PREDICATE","C_TEST","C_UNION","C_INT64","C_UINT64","C_FLOAT","C_STRING",
"C_BOOLEAN",0,0,0,0,0,0,0,0,"'['",0,"']'",0,"'_'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,"'{'","'|'","'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"error","\":=\"",
"\"&&\"","\"::\"","\"==\"","\"..\"","\"...\"","\"//\"","\"||\"","\">=\"",
"\"<=\"","\"!=\"","\"+=\"","\"comment\"","\"id\"","\"key\"","\"node\"",
"\"processing-instruction\"","\"text\"","\"and\"","\"div\"","\"mod\"","\"or\"",
"$accept","start","xpath_union_expression","q_name","xpath_value",
"xpath_expression","xp_expr","xp_union_expr","and_operator","or_operator",
"equals_operator","xp_location_path","xpc_relative_location_path",
"xp_absolute_location_path","xp_relative_location_path_optional",
"xpc_abbreviated_absolute_location_path","xp_ternary_expr","xp_or_expr",
"xp_primary_expr","xpc_expr","xpc_variable_reference","xpc_literal",
"xpc_number","xpc_function_call","xp_not_expr","xp_path_expr","xp_filter_expr",
"xpc_predicate","xp_and_expr","xp_equality_expr","xp_relational_expr",
"xp_concative_expr","xp_additive_expr","xp_multiplicative_expr","xp_unary_expr",
"xpc_argument_list_optional","xpc_argument_list","xpc_argument",
"xpc_axis_specifier_optional","xpc_abbreviated_axis_specifier",
"xpc_predicate_list","xpc_step","xpc_abbreviated_relative_location_path",
"xpc_node_test","xpc_abbreviated_step","xpc_literal_optional","xpc_name_test",
"xpc_node_type","illegal-symbol",
};
static const char *const xo_xpath_yyrule[] = {
"$accept : start",
"start : xpath_union_expression",
"q_name : T_BARE",
"xpath_value : xpath_expression",
"xpath_expression : xp_expr",
"xpath_union_expression : xp_union_expr",
"and_operator : K_AND",
"and_operator : L_DAMPER",
"or_operator : K_OR",
"or_operator : L_DVBAR",
"equals_operator : L_EQUALS",
"equals_operator : L_DEQUALS",
"xp_location_path : xpc_relative_location_path",
"xp_location_path : xp_absolute_location_path",
"xp_absolute_location_path : L_SLASH xp_relative_location_path_optional",
"xp_absolute_location_path : xpc_abbreviated_absolute_location_path",
"xp_expr : xp_ternary_expr",
"xp_ternary_expr : xp_or_expr",
"xp_ternary_expr : xp_or_expr L_QUESTION xp_or_expr L_COLON xp_ternary_expr",
"xp_ternary_expr : xp_or_expr L_QUESTION L_COLON xp_ternary_expr",
"xp_primary_expr : L_OPAREN xpc_expr L_CPAREN",
"xp_primary_expr : xpc_variable_reference",
"xp_primary_expr : xpc_literal",
"xp_primary_expr : xpc_number",
"xp_primary_expr : xpc_function_call",
"xp_union_expr : xp_not_expr",
"xp_union_expr : xp_union_expr L_VBAR xp_not_expr",
"xp_not_expr : xp_path_expr",
"xp_not_expr : L_NOT xp_path_expr",
"xp_path_expr : xp_location_path",
"xp_path_expr : xp_filter_expr",
"xp_path_expr : xp_filter_expr L_SLASH xpc_relative_location_path",
"xp_path_expr : xp_filter_expr L_DSLASH xpc_relative_location_path",
"xp_filter_expr : xp_primary_expr",
"xp_filter_expr : xp_filter_expr xpc_predicate",
"xp_or_expr : xp_and_expr",
"xp_or_expr : xp_or_expr or_operator xp_and_expr",
"xp_and_expr : xp_equality_expr",
"xp_and_expr : xp_and_expr and_operator xp_equality_expr",
"xp_equality_expr : xp_relational_expr",
"xp_equality_expr : xp_equality_expr equals_operator xp_relational_expr",
"xp_equality_expr : xp_equality_expr L_NOTEQUALS xp_relational_expr",
"xp_concative_expr : xp_additive_expr",
"xp_concative_expr : xp_concative_expr L_UNDERSCORE xp_additive_expr",
"xp_additive_expr : xp_multiplicative_expr",
"xp_additive_expr : xp_additive_expr L_PLUS xp_multiplicative_expr",
"xp_additive_expr : xp_additive_expr L_MINUS xp_multiplicative_expr",
"xp_multiplicative_expr : xp_unary_expr",
"xp_multiplicative_expr : xp_multiplicative_expr L_STAR xp_unary_expr",
"xp_multiplicative_expr : xp_multiplicative_expr K_DIV xp_unary_expr",
"xp_multiplicative_expr : xp_multiplicative_expr K_MOD xp_unary_expr",
"xp_unary_expr : xp_union_expr",
"xp_unary_expr : L_MINUS xp_unary_expr",
"xp_relative_location_path_optional :",
"xp_relative_location_path_optional : xpc_relative_location_path",
"xpc_function_call : T_FUNCTION_NAME L_OPAREN xpc_argument_list_optional L_CPAREN",
"xpc_argument_list_optional :",
"xpc_argument_list_optional : xpc_argument_list",
"xpc_argument_list : xpc_argument",
"xpc_argument_list : xpc_argument_list L_COMMA xpc_argument",
"xpc_argument : xpath_value",
"xpc_axis_specifier_optional :",
"xpc_axis_specifier_optional : T_AXIS_NAME L_DCOLON",
"xpc_axis_specifier_optional : xpc_abbreviated_axis_specifier",
"xpc_predicate_list :",
"xpc_predicate_list : xpc_predicate_list xpc_predicate",
"xpc_predicate : L_OBRACK xpath_expression L_CBRACK",
"xpc_relative_location_path : xpc_step",
"xpc_relative_location_path : xpc_relative_location_path L_SLASH xpc_step",
"xpc_relative_location_path : xpc_abbreviated_relative_location_path",
"xpc_step : xpc_axis_specifier_optional xpc_node_test xpc_predicate_list",
"xpc_step : xpc_abbreviated_step",
"xpc_abbreviated_absolute_location_path : L_DSLASH xpc_relative_location_path",
"xpc_abbreviated_relative_location_path : xpc_relative_location_path L_DSLASH xpc_step",
"xpc_literal : T_QUOTED",
"xpc_literal_optional :",
"xpc_literal_optional : xpc_literal",
"xpc_number : T_NUMBER",
"xpc_variable_reference : T_VAR",
"xpc_node_test : xpc_name_test",
"xpc_node_test : xpc_node_type L_OPAREN L_CPAREN",
"xpc_node_test : K_PROCESSING_INSTRUCTION L_OPAREN xpc_literal_optional L_CPAREN",
"xpc_name_test : q_name",
"xpc_name_test : L_ASTERISK",
"xpc_node_type : K_COMMENT",
"xpc_node_type : K_TEXT",
"xpc_node_type : K_NODE",
"xpc_abbreviated_step : L_DOT",
"xpc_abbreviated_step : L_DOTDOT",
"xpc_abbreviated_axis_specifier : L_AT",
"xpc_expr : xp_expr",
"xp_relational_expr : xp_concative_expr",
"xp_relational_expr : xp_relational_expr L_LESS xp_concative_expr",
"xp_relational_expr : xp_relational_expr L_GRTR xp_concative_expr",
"xp_relational_expr : xp_relational_expr L_LESSEQ xp_concative_expr",
"xp_relational_expr : xp_relational_expr L_GRTREQ xp_concative_expr",

};
#endif

#if YYDEBUG
int      yydebug;
#endif

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
#ifndef YYLLOC_DEFAULT
#define YYLLOC_DEFAULT(loc, rhs, n) \
do \
{ \
    if (n == 0) \
    { \
        (loc).first_line   = YYRHSLOC(rhs, 0).last_line; \
        (loc).first_column = YYRHSLOC(rhs, 0).last_column; \
        (loc).last_line    = YYRHSLOC(rhs, 0).last_line; \
        (loc).last_column  = YYRHSLOC(rhs, 0).last_column; \
    } \
    else \
    { \
        (loc).first_line   = YYRHSLOC(rhs, 1).first_line; \
        (loc).first_column = YYRHSLOC(rhs, 1).first_column; \
        (loc).last_line    = YYRHSLOC(rhs, n).last_line; \
        (loc).last_column  = YYRHSLOC(rhs, n).last_column; \
    } \
} while (0)
#endif /* YYLLOC_DEFAULT */
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
#if YYBTYACC

#ifndef YYLVQUEUEGROWTH
#define YYLVQUEUEGROWTH 32
#endif
#endif /* YYBTYACC */

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH  10000
#endif
#endif

#ifndef YYINITSTACKSIZE
#define YYINITSTACKSIZE 200
#endif

typedef struct {
    unsigned stacksize;
    YYINT    *s_base;
    YYINT    *s_mark;
    YYINT    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    YYLTYPE  *p_base;
    YYLTYPE  *p_mark;
#endif
} YYSTACKDATA;
#if YYBTYACC

struct YYParseState_s
{
    struct YYParseState_s *save;    /* Previously saved parser state */
    YYSTACKDATA            yystack; /* saved parser stack */
    int                    state;   /* saved parser state */
    int                    errflag; /* saved error recovery status */
    int                    lexeme;  /* saved index of the conflict lexeme in the lexical queue */
    YYINT                  ctry;    /* saved index in yyctable[] for this conflict */
};
typedef struct YYParseState_s YYParseState;
#endif /* YYBTYACC */
#line 812 "../../libxo/xo_xpath.y"

#ifndef XO_YYDEBUG
#undef yydebug
#define yydebug 0
#endif /* XO_YYDEBUG */

/*
 * These definitions need values and defines that are internal to
 * yacc, so they must be placed here.
 */

#ifndef YYNTOKENS
#ifdef YYMAXTOKEN
#define YYNTOKENS (YYMAXTOKEN+1)
#else
#error unknown value for YYNTOKENS
#endif /* YYMAXTOKEN */
#endif /* YYNTOKENS */

#ifndef YYLAST
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST ((sizeof(yytable) / sizeof(yytable[0])) - 1)
#endif /* YYLAST */

const int xo_xparse_num_tokens = YYNTOKENS;
const char *xo_xparse_keyword_string[YYNTOKENS];
const char *xo_xparse_token_name_fancy[YYNTOKENS];

/*
 * Return a human-readable name for a given token type
 */
const char *
xo_xparse_token_name (xo_xparse_token_t ttype)
{
    if (ttype >= YYNTOKENS)
	return "unknown";

    return yytname[YYTRANSLATE(ttype)];
}

const char *
xo_xparse_fancy_token_name (xo_xparse_token_t ttype)
{
    if (ttype >= YYNTOKENS)
	return "unknown";

    return xo_xparse_token_name_fancy[YYTRANSLATE(ttype)];
}

/*
 * Expose YYTRANSLATE outside the yacc file
 */
xo_xparse_token_t
xo_xparse_token_translate (xo_xparse_token_t ttype)
{
    return YYTRANSLATE(ttype);
}

#ifndef YYTERROR
#define YYTERROR YYSYMBOL_YYerror /* the new enum */
#endif /* YYTERROR */

/*
 * Return a better class of error message, if possible.  But it turns
 * out that this isn't possible in yacc.  bison adds a "lookahead
 * correction" that gives us information that we can use to find the
 * list of possibly-valid next tokens, which we use to build an
 * "expecting ..." message, but lacking that information, we just punt.
 *
 * The original code is in libslax/slaxparser.y, so maybe one day I'll
 * try to make it work.
 */
char *
xo_xparse_expecting_error (const char *token, int yystate UNUSED,
			   int yychar UNUSED)
{
    char buf[BUFSIZ], *cp = buf, *ep = buf + sizeof(buf);

    SNPRINTF(cp, ep, "unexpected input");
    if (token)
	SNPRINTF(cp, ep, ": %s", token);

    return strdup(buf);
}
#line 1107 "xo_xpath.tab.c"

/* For use in generated program */
#define yydepth (int)(yystack.s_mark - yystack.s_base)
#if YYBTYACC
#define yytrial (yyps->save)
#endif /* YYBTYACC */

#if YYDEBUG
#include <stdio.h>	/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    YYINT *newss;
    YYSTYPE *newvs;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    YYLTYPE *newps;
#endif

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return YYENOMEM;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = (int) (data->s_mark - data->s_base);
    newss = (YYINT *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return YYENOMEM;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return YYENOMEM;

    data->l_base = newvs;
    data->l_mark = newvs + i;

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    newps = (YYLTYPE *)realloc(data->p_base, newsize * sizeof(*newps));
    if (newps == 0)
        return YYENOMEM;

    data->p_base = newps;
    data->p_mark = newps + i;
#endif

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;

#if YYDEBUG
    if (yydebug)
        fprintf(stderr, "%sdebug: stack size increased to %d\n", YYPREFIX, newsize);
#endif
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    free(data->p_base);
#endif
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif /* YYPURE || defined(YY_NO_LEAKS) */
#if YYBTYACC

static YYParseState *
yyNewState(unsigned size)
{
    YYParseState *p = (YYParseState *) malloc(sizeof(YYParseState));
    if (p == NULL) return NULL;

    p->yystack.stacksize = size;
    if (size == 0)
    {
        p->yystack.s_base = NULL;
        p->yystack.l_base = NULL;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        p->yystack.p_base = NULL;
#endif
        return p;
    }
    p->yystack.s_base    = (YYINT *) malloc(size * sizeof(YYINT));
    if (p->yystack.s_base == NULL) return NULL;
    p->yystack.l_base    = (YYSTYPE *) malloc(size * sizeof(YYSTYPE));
    if (p->yystack.l_base == NULL) return NULL;
    memset(p->yystack.l_base, 0, size * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    p->yystack.p_base    = (YYLTYPE *) malloc(size * sizeof(YYLTYPE));
    if (p->yystack.p_base == NULL) return NULL;
    memset(p->yystack.p_base, 0, size * sizeof(YYLTYPE));
#endif

    return p;
}

static void
yyFreeState(YYParseState *p)
{
    yyfreestack(&p->yystack);
    free(p);
}
#endif /* YYBTYACC */

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab
#if YYBTYACC
#define YYVALID        do { if (yyps->save)            goto yyvalid; } while(0)
#define YYVALID_NESTED do { if (yyps->save && \
                                yyps->save->save == 0) goto yyvalid; } while(0)
#endif /* YYBTYACC */

int
YYPARSE_DECL()
{
    int      yyerrflag;
    int      yychar;
    YYSTYPE  yyval;
    YYSTYPE  yylval;
    int      yynerrs;

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    YYLTYPE  yyloc; /* position returned by actions */
    YYLTYPE  yylloc; /* position from the lexer */
#endif

    /* variables for the parser stack */
    YYSTACKDATA yystack;
#if YYBTYACC

    /* Current parser state */
    static YYParseState *yyps = 0;

    /* yypath != NULL: do the full parse, starting at *yypath parser state. */
    static YYParseState *yypath = 0;

    /* Base of the lexical value queue */
    static YYSTYPE *yylvals = 0;

    /* Current position at lexical value queue */
    static YYSTYPE *yylvp = 0;

    /* End position of lexical value queue */
    static YYSTYPE *yylve = 0;

    /* The last allocated position at the lexical value queue */
    static YYSTYPE *yylvlim = 0;

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    /* Base of the lexical position queue */
    static YYLTYPE *yylpsns = 0;

    /* Current position at lexical position queue */
    static YYLTYPE *yylpp = 0;

    /* End position of lexical position queue */
    static YYLTYPE *yylpe = 0;

    /* The last allocated position at the lexical position queue */
    static YYLTYPE *yylplim = 0;
#endif

    /* Current position at lexical token queue */
    static YYINT  *yylexp = 0;

    static YYINT  *yylexemes = 0;
#endif /* YYBTYACC */
    int yym, yyn, yystate, yyresult;
#if YYBTYACC
    int yynewerrflag;
    YYParseState *yyerrctx = NULL;
#endif /* YYBTYACC */
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    YYLTYPE  yyerror_loc_range[3]; /* position of error start/end (0 unused) */
#endif
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            do {} while(0);
    }
    if (yydebug)
        fprintf(stderr, "%sdebug[<# of symbols on state stack>]\n", YYPREFIX);
#endif
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    memset(yyerror_loc_range, 0, sizeof(yyerror_loc_range));
#endif

    yyerrflag = 0;
    yychar = 0;
    memset(&yyval,  0, sizeof(yyval));
    memset(&yylval, 0, sizeof(yylval));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    memset(&yyloc,  0, sizeof(yyloc));
    memset(&yylloc, 0, sizeof(yylloc));
#endif

#if YYBTYACC
    yyps = yyNewState(0); if (yyps == 0) goto yyenomem;
    yyps->save = 0;
#endif /* YYBTYACC */
    yym = 0;
    /* yyn is set below */
    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark = yystack.p_base;
#endif
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
#if YYBTYACC
        do {
        if (yylvp < yylve)
        {
            /* we're currently re-reading tokens */
            yylval = *yylvp++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yylloc = *yylpp++;
#endif
            yychar = *yylexp++;
            break;
        }
        if (yyps->save)
        {
            /* in trial mode; save scanner results for future parse attempts */
            if (yylvp == yylvlim)
            {   /* Enlarge lexical value queue */
                size_t p = (size_t) (yylvp - yylvals);
                size_t s = (size_t) (yylvlim - yylvals);

                s += YYLVQUEUEGROWTH;
                if ((yylexemes = (YYINT *)realloc(yylexemes, s * sizeof(YYINT))) == NULL) goto yyenomem;
                if ((yylvals   = (YYSTYPE *)realloc(yylvals, s * sizeof(YYSTYPE))) == NULL) goto yyenomem;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                if ((yylpsns   = (YYLTYPE *)realloc(yylpsns, s * sizeof(YYLTYPE))) == NULL) goto yyenomem;
#endif
                yylvp   = yylve = yylvals + p;
                yylvlim = yylvals + s;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylpp   = yylpe = yylpsns + p;
                yylplim = yylpsns + s;
#endif
                yylexp  = yylexemes + p;
            }
            *yylexp = (YYINT) YYLEX;
            *yylvp++ = yylval;
            yylve++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            *yylpp++ = yylloc;
            yylpe++;
#endif
            yychar = *yylexp++;
            break;
        }
        /* normal operation, no conflict encountered */
#endif /* YYBTYACC */
        yychar = YYLEX;
#if YYBTYACC
        } while (0);
#endif /* YYBTYACC */
        if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            fprintf(stderr, "%s[%d]: state %d, reading token %d (%s)",
                            YYDEBUGSTR, yydepth, yystate, yychar, yys);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
            if (!yytrial)
#endif /* YYBTYACC */
                fprintf(stderr, " <%s>", YYSTYPE_TOSTRING(yychar, yylval));
#endif
            fputc('\n', stderr);
        }
#endif
    }
#if YYBTYACC

    /* Do we have a conflict? */
    if (((yyn = yycindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
        yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
        YYINT ctry;

        if (yypath)
        {
            YYParseState *save;
#if YYDEBUG
            if (yydebug)
                fprintf(stderr, "%s[%d]: CONFLICT in state %d: following successful trial parse\n",
                                YYDEBUGSTR, yydepth, yystate);
#endif
            /* Switch to the next conflict context */
            save = yypath;
            yypath = save->save;
            save->save = NULL;
            ctry = save->ctry;
            if (save->state != yystate) YYABORT;
            yyFreeState(save);

        }
        else
        {

            /* Unresolved conflict - start/continue trial parse */
            YYParseState *save;
#if YYDEBUG
            if (yydebug)
            {
                fprintf(stderr, "%s[%d]: CONFLICT in state %d. ", YYDEBUGSTR, yydepth, yystate);
                if (yyps->save)
                    fputs("ALREADY in conflict, continuing trial parse.\n", stderr);
                else
                    fputs("Starting trial parse.\n", stderr);
            }
#endif
            save                  = yyNewState((unsigned)(yystack.s_mark - yystack.s_base + 1));
            if (save == NULL) goto yyenomem;
            save->save            = yyps->save;
            save->state           = yystate;
            save->errflag         = yyerrflag;
            save->yystack.s_mark  = save->yystack.s_base + (yystack.s_mark - yystack.s_base);
            memcpy (save->yystack.s_base, yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
            save->yystack.l_mark  = save->yystack.l_base + (yystack.l_mark - yystack.l_base);
            memcpy (save->yystack.l_base, yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            save->yystack.p_mark  = save->yystack.p_base + (yystack.p_mark - yystack.p_base);
            memcpy (save->yystack.p_base, yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
            ctry                  = yytable[yyn];
            if (yyctable[ctry] == -1)
            {
#if YYDEBUG
                if (yydebug && yychar >= YYEOF)
                    fprintf(stderr, "%s[%d]: backtracking 1 token\n", YYDEBUGSTR, yydepth);
#endif
                ctry++;
            }
            save->ctry = ctry;
            if (yyps->save == NULL)
            {
                /* If this is a first conflict in the stack, start saving lexemes */
                if (!yylexemes)
                {
                    yylexemes = (YYINT *) malloc((YYLVQUEUEGROWTH) * sizeof(YYINT));
                    if (yylexemes == NULL) goto yyenomem;
                    yylvals   = (YYSTYPE *) malloc((YYLVQUEUEGROWTH) * sizeof(YYSTYPE));
                    if (yylvals == NULL) goto yyenomem;
                    yylvlim   = yylvals + YYLVQUEUEGROWTH;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    yylpsns   = (YYLTYPE *) malloc((YYLVQUEUEGROWTH) * sizeof(YYLTYPE));
                    if (yylpsns == NULL) goto yyenomem;
                    yylplim   = yylpsns + YYLVQUEUEGROWTH;
#endif
                }
                if (yylvp == yylve)
                {
                    yylvp  = yylve = yylvals;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    yylpp  = yylpe = yylpsns;
#endif
                    yylexp = yylexemes;
                    if (yychar >= YYEOF)
                    {
                        *yylve++ = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                        *yylpe++ = yylloc;
#endif
                        *yylexp  = (YYINT) yychar;
                        yychar   = YYEMPTY;
                    }
                }
            }
            if (yychar >= YYEOF)
            {
                yylvp--;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylpp--;
#endif
                yylexp--;
                yychar = YYEMPTY;
            }
            save->lexeme = (int) (yylvp - yylvals);
            yyps->save   = save;
        }
        if (yytable[yyn] == ctry)
        {
#if YYDEBUG
            if (yydebug)
                fprintf(stderr, "%s[%d]: state %d, shifting to state %d\n",
                                YYDEBUGSTR, yydepth, yystate, yyctable[ctry]);
#endif
            if (yychar < 0)
            {
                yylvp++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylpp++;
#endif
                yylexp++;
            }
            if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM)
                goto yyoverflow;
            yystate = yyctable[ctry];
            *++yystack.s_mark = (YYINT) yystate;
            *++yystack.l_mark = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            *++yystack.p_mark = yylloc;
#endif
            yychar  = YYEMPTY;
            if (yyerrflag > 0) --yyerrflag;
            goto yyloop;
        }
        else
        {
            yyn = yyctable[ctry];
            goto yyreduce;
        }
    } /* End of code dealing with conflicts */
#endif /* YYBTYACC */
    if (((yyn = yysindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
#if YYDEBUG
        if (yydebug)
            fprintf(stderr, "%s[%d]: state %d, shifting to state %d\n",
                            YYDEBUGSTR, yydepth, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        *++yystack.p_mark = yylloc;
#endif
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if (((yyn = yyrindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag != 0) goto yyinrecovery;
#if YYBTYACC

    yynewerrflag = 1;
    goto yyerrhandler;
    goto yyerrlab; /* redundant goto avoids 'unused label' warning */

yyerrlab:
    /* explicit YYERROR from an action -- pop the rhs of the rule reduced
     * before looking for error recovery */
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark -= yym;
#endif

    yynewerrflag = 0;
yyerrhandler:
    while (yyps->save)
    {
        int ctry;
        YYParseState *save = yyps->save;
#if YYDEBUG
        if (yydebug)
            fprintf(stderr, "%s[%d]: ERROR in state %d, CONFLICT BACKTRACKING to state %d, %d tokens\n",
                            YYDEBUGSTR, yydepth, yystate, yyps->save->state,
                    (int)(yylvp - yylvals - yyps->save->lexeme));
#endif
        /* Memorize most forward-looking error state in case it's really an error. */
        if (yyerrctx == NULL || yyerrctx->lexeme < yylvp - yylvals)
        {
            /* Free old saved error context state */
            if (yyerrctx) yyFreeState(yyerrctx);
            /* Create and fill out new saved error context state */
            yyerrctx                 = yyNewState((unsigned)(yystack.s_mark - yystack.s_base + 1));
            if (yyerrctx == NULL) goto yyenomem;
            yyerrctx->save           = yyps->save;
            yyerrctx->state          = yystate;
            yyerrctx->errflag        = yyerrflag;
            yyerrctx->yystack.s_mark = yyerrctx->yystack.s_base + (yystack.s_mark - yystack.s_base);
            memcpy (yyerrctx->yystack.s_base, yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
            yyerrctx->yystack.l_mark = yyerrctx->yystack.l_base + (yystack.l_mark - yystack.l_base);
            memcpy (yyerrctx->yystack.l_base, yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yyerrctx->yystack.p_mark = yyerrctx->yystack.p_base + (yystack.p_mark - yystack.p_base);
            memcpy (yyerrctx->yystack.p_base, yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
            yyerrctx->lexeme         = (int) (yylvp - yylvals);
        }
        yylvp          = yylvals   + save->lexeme;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        yylpp          = yylpsns   + save->lexeme;
#endif
        yylexp         = yylexemes + save->lexeme;
        yychar         = YYEMPTY;
        yystack.s_mark = yystack.s_base + (save->yystack.s_mark - save->yystack.s_base);
        memcpy (yystack.s_base, save->yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
        yystack.l_mark = yystack.l_base + (save->yystack.l_mark - save->yystack.l_base);
        memcpy (yystack.l_base, save->yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        yystack.p_mark = yystack.p_base + (save->yystack.p_mark - save->yystack.p_base);
        memcpy (yystack.p_base, save->yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
        ctry           = ++save->ctry;
        yystate        = save->state;
        /* We tried shift, try reduce now */
        if ((yyn = yyctable[ctry]) >= 0) goto yyreduce;
        yyps->save     = save->save;
        save->save     = NULL;
        yyFreeState(save);

        /* Nothing left on the stack -- error */
        if (!yyps->save)
        {
#if YYDEBUG
            if (yydebug)
                fprintf(stderr, "%sdebug[%d,trial]: trial parse FAILED, entering ERROR mode\n",
                                YYPREFIX, yydepth);
#endif
            /* Restore state as it was in the most forward-advanced error */
            yylvp          = yylvals   + yyerrctx->lexeme;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yylpp          = yylpsns   + yyerrctx->lexeme;
#endif
            yylexp         = yylexemes + yyerrctx->lexeme;
            yychar         = yylexp[-1];
            yylval         = yylvp[-1];
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yylloc         = yylpp[-1];
#endif
            yystack.s_mark = yystack.s_base + (yyerrctx->yystack.s_mark - yyerrctx->yystack.s_base);
            memcpy (yystack.s_base, yyerrctx->yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
            yystack.l_mark = yystack.l_base + (yyerrctx->yystack.l_mark - yyerrctx->yystack.l_base);
            memcpy (yystack.l_base, yyerrctx->yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yystack.p_mark = yystack.p_base + (yyerrctx->yystack.p_mark - yyerrctx->yystack.p_base);
            memcpy (yystack.p_base, yyerrctx->yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
            yystate        = yyerrctx->state;
            yyFreeState(yyerrctx);
            yyerrctx       = NULL;
        }
        yynewerrflag = 1;
    }
    if (yynewerrflag == 0) goto yyinrecovery;
#endif /* YYBTYACC */

    YYERROR_CALL("syntax error");
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yyerror_loc_range[1] = yylloc; /* lookahead position is error start position */
#endif

#if !YYBTYACC
    goto yyerrlab; /* redundant goto avoids 'unused label' warning */
yyerrlab:
#endif
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if (((yyn = yysindex[*yystack.s_mark]) != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    fprintf(stderr, "%s[%d]: state %d, error recovery shifting to state %d\n",
                                    YYDEBUGSTR, yydepth, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                /* lookahead position is error end position */
                yyerror_loc_range[2] = yylloc;
                YYLLOC_DEFAULT(yyloc, yyerror_loc_range, 2); /* position of error span */
                *++yystack.p_mark = yyloc;
#endif
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    fprintf(stderr, "%s[%d]: error recovery discarding state %d\n",
                                    YYDEBUGSTR, yydepth, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                /* the current TOS position is the error start position */
                yyerror_loc_range[1] = *yystack.p_mark;
#endif
#if defined(YYDESTRUCT_CALL)
#if YYBTYACC
                if (!yytrial)
#endif /* YYBTYACC */
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    YYDESTRUCT_CALL("error: discarding state",
                                    yystos[*yystack.s_mark], yystack.l_mark, yystack.p_mark);
#else
                    YYDESTRUCT_CALL("error: discarding state",
                                    yystos[*yystack.s_mark], yystack.l_mark);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
#endif /* defined(YYDESTRUCT_CALL) */
                --yystack.s_mark;
                --yystack.l_mark;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                --yystack.p_mark;
#endif
            }
        }
    }
    else
    {
        if (yychar == YYEOF) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            fprintf(stderr, "%s[%d]: state %d, error recovery discarding token %d (%s)\n",
                            YYDEBUGSTR, yydepth, yystate, yychar, yys);
        }
#endif
#if defined(YYDESTRUCT_CALL)
#if YYBTYACC
        if (!yytrial)
#endif /* YYBTYACC */
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            YYDESTRUCT_CALL("error: discarding token", yychar, &yylval, &yylloc);
#else
            YYDESTRUCT_CALL("error: discarding token", yychar, &yylval);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
#endif /* defined(YYDESTRUCT_CALL) */
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
    yym = yylen[yyn];
#if YYDEBUG
    if (yydebug)
    {
        fprintf(stderr, "%s[%d]: state %d, reducing by rule %d (%s)",
                        YYDEBUGSTR, yydepth, yystate, yyn, yyrule[yyn]);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
        if (!yytrial)
#endif /* YYBTYACC */
            if (yym > 0)
            {
                int i;
                fputc('<', stderr);
                for (i = yym; i > 0; i--)
                {
                    if (i != yym) fputs(", ", stderr);
                    fputs(YYSTYPE_TOSTRING(yystos[yystack.s_mark[1-i]],
                                           yystack.l_mark[1-i]), stderr);
                }
                fputc('>', stderr);
            }
#endif
        fputc('\n', stderr);
    }
#endif
    if (yym > 0)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)

    /* Perform position reduction */
    memset(&yyloc, 0, sizeof(yyloc));
#if YYBTYACC
    if (!yytrial)
#endif /* YYBTYACC */
    {
        YYLLOC_DEFAULT(yyloc, &yystack.p_mark[-yym], yym);
        /* just in case YYERROR is invoked within the action, save
           the start of the rhs as the error start position */
        yyerror_loc_range[1] = yystack.p_mark[1-yym];
    }
#endif

    switch (yyn)
    {
case 1:
#line 251 "../../libxo/xo_xpath.y"
	{
		    yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]);
		    xo_xparse_results(xparse_data, yystack.l_mark[0]);
		    xparse_data->xd_errors = yynerrs;
		}
#line 1845 "xo_xpath.tab.c"
break;
case 2:
#line 260 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 1850 "xo_xpath.tab.c"
break;
case 3:
#line 265 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 1855 "xo_xpath.tab.c"
break;
case 4:
#line 270 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 1860 "xo_xpath.tab.c"
break;
case 5:
#line 275 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 1865 "xo_xpath.tab.c"
break;
case 6:
#line 282 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 1870 "xo_xpath.tab.c"
break;
case 7:
#line 285 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_node_ok(xparse_data, yyval)->xn_type = K_AND;
		}
#line 1877 "xo_xpath.tab.c"
break;
case 8:
#line 292 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 1882 "xo_xpath.tab.c"
break;
case 9:
#line 295 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_node_ok(xparse_data, yyval)->xn_type = K_OR;
		}
#line 1889 "xo_xpath.tab.c"
break;
case 10:
#line 302 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 1894 "xo_xpath.tab.c"
break;
case 11:
#line 305 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_node_ok(xparse_data, yyval)->xn_type = L_EQUALS;
		}
#line 1901 "xo_xpath.tab.c"
break;
case 12:
#line 312 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 1906 "xo_xpath.tab.c"
break;
case 13:
#line 315 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 1911 "xo_xpath.tab.c"
break;
case 14:
#line 320 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_node_set_type(xparse_data, yystack.l_mark[-1], C_ABSOLUTE);
		    xo_xparse_node_set_next(xparse_data, yystack.l_mark[-1], yystack.l_mark[0]);
		    yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-1]);
		}
#line 1920 "xo_xpath.tab.c"
break;
case 15:
#line 327 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 1925 "xo_xpath.tab.c"
break;
case 16:
#line 332 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 1930 "xo_xpath.tab.c"
break;
case 17:
#line 337 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 1935 "xo_xpath.tab.c"
break;
case 18:
#line 340 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_ternary_rewrite(xparse_data, &yyval, &yystack.l_mark[-4], &yystack.l_mark[-3], &yystack.l_mark[-2], &yystack.l_mark[-1], &yystack.l_mark[0]);
		}
#line 1942 "xo_xpath.tab.c"
break;
case 19:
#line 345 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_ternary_rewrite(xparse_data, &yyval, &yystack.l_mark[-3], &yystack.l_mark[-2], NULL, &yystack.l_mark[-1], &yystack.l_mark[0]);
		}
#line 1949 "xo_xpath.tab.c"
break;
case 20:
#line 352 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_node_set_type(xparse_data, yystack.l_mark[-2], C_EXPR);
		    xo_xparse_node_set_contents(xparse_data, yystack.l_mark[-2], yystack.l_mark[-1]);
		    yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-2]);
		}
#line 1958 "xo_xpath.tab.c"
break;
case 21:
#line 359 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 1963 "xo_xpath.tab.c"
break;
case 22:
#line 362 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 1968 "xo_xpath.tab.c"
break;
case 23:
#line 365 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 1973 "xo_xpath.tab.c"
break;
case 24:
#line 368 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 1978 "xo_xpath.tab.c"
break;
case 25:
#line 373 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 1983 "xo_xpath.tab.c"
break;
case 26:
#line 376 "../../libxo/xo_xpath.y"
	{
		    if (xo_xparse_node_type(xparse_data, yystack.l_mark[-2]) == C_UNION) {
			
			xo_xparse_node_set_next(xparse_data,
				xo_xparse_node_contents(xparse_data, yystack.l_mark[-2]),
						yystack.l_mark[0]);
			yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-2]);
		    } else {
			xo_xparse_node_set_type(xparse_data, yystack.l_mark[-1], C_UNION);
			xo_xparse_node_set_contents(xparse_data, yystack.l_mark[-1], yystack.l_mark[-2]);
			xo_xparse_node_set_next(xparse_data, yystack.l_mark[-2], yystack.l_mark[0]);
			yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-1]);
		    }
		}
#line 2001 "xo_xpath.tab.c"
break;
case 27:
#line 394 "../../libxo/xo_xpath.y"
	{ 
		    xo_xparse_node_id_t id = xo_xparse_node_new(xparse_data);
		    xo_xparse_node_t *xnp = xo_xparse_node(xparse_data, yystack.l_mark[0]);
		    if (xnp->xn_type == C_ELEMENT) {
			xnp = xo_xparse_node(xparse_data, id);
			xnp->xn_type = C_PATH;
			xo_xparse_node_set_contents(xparse_data, id, yystack.l_mark[0]);
		    } else {
			id = yystack.l_mark[0];
		    }
		    yyval = xo_xparse_yyval(xparse_data, id);
		}
#line 2017 "xo_xpath.tab.c"
break;
case 28:
#line 408 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_node_set_type(xparse_data, yystack.l_mark[-1], C_NOT);
		    xo_xparse_node_set_contents(xparse_data, yystack.l_mark[-1], yystack.l_mark[0]);
		    yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-1]);
		}
#line 2026 "xo_xpath.tab.c"
break;
case 29:
#line 417 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2031 "xo_xpath.tab.c"
break;
case 30:
#line 420 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2036 "xo_xpath.tab.c"
break;
case 31:
#line 423 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_node_set_next(xparse_data, yystack.l_mark[-2], yystack.l_mark[-1]);
		    xo_xparse_node_set_next(xparse_data, yystack.l_mark[-1], yystack.l_mark[0]);
		    yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-2]);
		}
#line 2045 "xo_xpath.tab.c"
break;
case 32:
#line 430 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_node_set_next(xparse_data, yystack.l_mark[-2], yystack.l_mark[-1]);
		    xo_xparse_node_set_next(xparse_data, yystack.l_mark[-1], yystack.l_mark[0]);
		    yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-2]);
		}
#line 2054 "xo_xpath.tab.c"
break;
case 33:
#line 439 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2059 "xo_xpath.tab.c"
break;
case 34:
#line 442 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_node_set_next(xparse_data, yystack.l_mark[-1], yystack.l_mark[0]);
		    yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-1]);
		}
#line 2067 "xo_xpath.tab.c"
break;
case 35:
#line 450 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2072 "xo_xpath.tab.c"
break;
case 36:
#line 453 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_node_set_contents(xparse_data, yystack.l_mark[-1], yystack.l_mark[-2]);
		    xo_xparse_node_set_next(xparse_data, yystack.l_mark[-2], yystack.l_mark[0]);
		    yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-1]);
		}
#line 2081 "xo_xpath.tab.c"
break;
case 37:
#line 462 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2086 "xo_xpath.tab.c"
break;
case 38:
#line 465 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_node_set_contents(xparse_data, yystack.l_mark[-1], yystack.l_mark[-2]);
		    xo_xparse_node_set_next(xparse_data, yystack.l_mark[-2], yystack.l_mark[0]);
		    yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-1]);
		}
#line 2095 "xo_xpath.tab.c"
break;
case 39:
#line 474 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2100 "xo_xpath.tab.c"
break;
case 40:
#line 477 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_node_set_contents(xparse_data, yystack.l_mark[-1], yystack.l_mark[-2]);
		    xo_xparse_node_set_next(xparse_data, yystack.l_mark[-2], yystack.l_mark[0]);
		    yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-1]);
		}
#line 2109 "xo_xpath.tab.c"
break;
case 41:
#line 484 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_node_set_contents(xparse_data, yystack.l_mark[-1], yystack.l_mark[-2]);
		    xo_xparse_node_set_next(xparse_data, yystack.l_mark[-2], yystack.l_mark[0]);
		    yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-1]);
		}
#line 2118 "xo_xpath.tab.c"
break;
case 42:
#line 493 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2123 "xo_xpath.tab.c"
break;
case 43:
#line 496 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_concat_rewrite(xparse_data, &yyval, &yystack.l_mark[-2], &yystack.l_mark[-1], &yystack.l_mark[0]);
		}
#line 2130 "xo_xpath.tab.c"
break;
case 44:
#line 503 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2135 "xo_xpath.tab.c"
break;
case 45:
#line 506 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_node_set_contents(xparse_data, yystack.l_mark[-1], yystack.l_mark[-2]);
		    xo_xparse_node_set_next(xparse_data, yystack.l_mark[-2], yystack.l_mark[0]);
		    yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-1]);
		}
#line 2144 "xo_xpath.tab.c"
break;
case 46:
#line 513 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_node_set_contents(xparse_data, yystack.l_mark[-1], yystack.l_mark[-2]);
		    xo_xparse_node_set_next(xparse_data, yystack.l_mark[-2], yystack.l_mark[0]);
		    yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-1]);
		}
#line 2153 "xo_xpath.tab.c"
break;
case 47:
#line 522 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2158 "xo_xpath.tab.c"
break;
case 48:
#line 525 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_node_set_contents(xparse_data, yystack.l_mark[-1], yystack.l_mark[-2]);
		    xo_xparse_node_set_next(xparse_data, yystack.l_mark[-2], yystack.l_mark[0]);
		    yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-1]);
		}
#line 2167 "xo_xpath.tab.c"
break;
case 49:
#line 532 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_node_set_contents(xparse_data, yystack.l_mark[-1], yystack.l_mark[-2]);
		    xo_xparse_node_set_next(xparse_data, yystack.l_mark[-2], yystack.l_mark[0]);
		    yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-1]);
		}
#line 2176 "xo_xpath.tab.c"
break;
case 50:
#line 539 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_node_set_contents(xparse_data, yystack.l_mark[-1], yystack.l_mark[-2]);
		    xo_xparse_node_set_next(xparse_data, yystack.l_mark[-2], yystack.l_mark[0]);
		    yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-1]);
		}
#line 2185 "xo_xpath.tab.c"
break;
case 51:
#line 548 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2190 "xo_xpath.tab.c"
break;
case 52:
#line 551 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_node_set_contents(xparse_data, yystack.l_mark[-1], yystack.l_mark[0]);
		    yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-1]);
		}
#line 2198 "xo_xpath.tab.c"
break;
case 53:
#line 561 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, 0); }
#line 2203 "xo_xpath.tab.c"
break;
case 54:
#line 564 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2208 "xo_xpath.tab.c"
break;
case 55:
#line 569 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-3]); }
#line 2213 "xo_xpath.tab.c"
break;
case 56:
#line 574 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, 0); }
#line 2218 "xo_xpath.tab.c"
break;
case 57:
#line 577 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2223 "xo_xpath.tab.c"
break;
case 58:
#line 582 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2228 "xo_xpath.tab.c"
break;
case 59:
#line 585 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_node_set_next(xparse_data, yystack.l_mark[-2], yystack.l_mark[-1]);
		    xo_xparse_node_set_next(xparse_data, yystack.l_mark[-1], yystack.l_mark[0]);
		    yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-2]);
		}
#line 2237 "xo_xpath.tab.c"
break;
case 60:
#line 594 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2242 "xo_xpath.tab.c"
break;
case 61:
#line 600 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, 0); }
#line 2247 "xo_xpath.tab.c"
break;
case 62:
#line 603 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_check_axis_name(xparse_data, yystack.l_mark[-1]);
		    yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-1]);
		}
#line 2255 "xo_xpath.tab.c"
break;
case 63:
#line 609 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2260 "xo_xpath.tab.c"
break;
case 64:
#line 614 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, 0); }
#line 2265 "xo_xpath.tab.c"
break;
case 65:
#line 617 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_node_set_next(xparse_data, yystack.l_mark[-1], yystack.l_mark[0]);
		    yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-1] ?: yystack.l_mark[0]);
		}
#line 2273 "xo_xpath.tab.c"
break;
case 66:
#line 625 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_node_set_type(xparse_data, yystack.l_mark[-2], C_PREDICATE);
		    xo_xparse_node_set_str(xparse_data, yystack.l_mark[-2], 0);
		    if (xo_xparse_node_type(xparse_data, yystack.l_mark[-1]) == T_NUMBER)
			xo_xparse_node_set_type(xparse_data, yystack.l_mark[-1], C_INDEX);
		    xo_xparse_node_set_contents(xparse_data, yystack.l_mark[-2], yystack.l_mark[-1]);
		    yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-2]);
		}
#line 2285 "xo_xpath.tab.c"
break;
case 67:
#line 637 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2290 "xo_xpath.tab.c"
break;
case 68:
#line 640 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_node_set_next(xparse_data, yystack.l_mark[-2], yystack.l_mark[0]);
		    yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-2]);
		}
#line 2298 "xo_xpath.tab.c"
break;
case 69:
#line 646 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2303 "xo_xpath.tab.c"
break;
case 70:
#line 651 "../../libxo/xo_xpath.y"
	{
		    if (xo_xparse_node_type(xparse_data, yystack.l_mark[-2]) == L_AT
			|| xo_xparse_node_is_attr_axis(xparse_data, yystack.l_mark[-2])) {
			xo_xparse_node_set_type(xparse_data, yystack.l_mark[-1], C_ATTRIBUTE);
		    } else {
			xo_xparse_node_set_contents(xparse_data, yystack.l_mark[-1], yystack.l_mark[-2]);
		    }
		    xo_xparse_node_set_contents(xparse_data, yystack.l_mark[-1], yystack.l_mark[0]);
		    yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-1]);
		}
#line 2317 "xo_xpath.tab.c"
break;
case 71:
#line 663 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2322 "xo_xpath.tab.c"
break;
case 72:
#line 668 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_node_set_type(xparse_data, yystack.l_mark[-1], C_DESCENDANT);
		    xo_xparse_node_set_next(xparse_data, yystack.l_mark[-1], yystack.l_mark[0]);
		    yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-1]);
		}
#line 2331 "xo_xpath.tab.c"
break;
case 73:
#line 677 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_node_set_type(xparse_data, yystack.l_mark[-1], C_DESCENDANT);
		    xo_xparse_node_set_next(xparse_data, yystack.l_mark[-2], yystack.l_mark[-1]);
		    xo_xparse_node_set_next(xparse_data, yystack.l_mark[-1], yystack.l_mark[0]);
		    yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-2] ?: yystack.l_mark[-1]);
		}
#line 2341 "xo_xpath.tab.c"
break;
case 74:
#line 687 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2346 "xo_xpath.tab.c"
break;
case 75:
#line 692 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, 0); }
#line 2351 "xo_xpath.tab.c"
break;
case 76:
#line 695 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2356 "xo_xpath.tab.c"
break;
case 77:
#line 700 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2361 "xo_xpath.tab.c"
break;
case 78:
#line 705 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2366 "xo_xpath.tab.c"
break;
case 79:
#line 710 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2371 "xo_xpath.tab.c"
break;
case 80:
#line 713 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-2]); }
#line 2376 "xo_xpath.tab.c"
break;
case 81:
#line 716 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_node_set_contents(xparse_data, yystack.l_mark[-3], yystack.l_mark[-1]);
		    yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-3]);
		}
#line 2384 "xo_xpath.tab.c"
break;
case 82:
#line 724 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_node_set_type(xparse_data, yystack.l_mark[0], C_ELEMENT);
		    yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]);
		}
#line 2392 "xo_xpath.tab.c"
break;
case 83:
#line 730 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2397 "xo_xpath.tab.c"
break;
case 84:
#line 735 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2402 "xo_xpath.tab.c"
break;
case 85:
#line 738 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2407 "xo_xpath.tab.c"
break;
case 86:
#line 741 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2412 "xo_xpath.tab.c"
break;
case 87:
#line 746 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2417 "xo_xpath.tab.c"
break;
case 88:
#line 749 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2422 "xo_xpath.tab.c"
break;
case 89:
#line 754 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2427 "xo_xpath.tab.c"
break;
case 90:
#line 763 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2432 "xo_xpath.tab.c"
break;
case 91:
#line 780 "../../libxo/xo_xpath.y"
	{ yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[0]); }
#line 2437 "xo_xpath.tab.c"
break;
case 92:
#line 783 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_node_set_contents(xparse_data, yystack.l_mark[-1], yystack.l_mark[-2]);
		    xo_xparse_node_set_next(xparse_data, yystack.l_mark[-2], yystack.l_mark[0]);
		    yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-1]);
		}
#line 2446 "xo_xpath.tab.c"
break;
case 93:
#line 790 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_node_set_contents(xparse_data, yystack.l_mark[-1], yystack.l_mark[-2]);
		    xo_xparse_node_set_next(xparse_data, yystack.l_mark[-2], yystack.l_mark[0]);
		    yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-1]);
		}
#line 2455 "xo_xpath.tab.c"
break;
case 94:
#line 797 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_node_set_contents(xparse_data, yystack.l_mark[-1], yystack.l_mark[-2]);
		    xo_xparse_node_set_next(xparse_data, yystack.l_mark[-2], yystack.l_mark[0]);
		    yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-1]);
		}
#line 2464 "xo_xpath.tab.c"
break;
case 95:
#line 804 "../../libxo/xo_xpath.y"
	{
		    xo_xparse_node_set_contents(xparse_data, yystack.l_mark[-1], yystack.l_mark[-2]);
		    xo_xparse_node_set_next(xparse_data, yystack.l_mark[-2], yystack.l_mark[0]);
		    yyval = xo_xparse_yyval(xparse_data, yystack.l_mark[-1]);
		}
#line 2473 "xo_xpath.tab.c"
break;
#line 2475 "xo_xpath.tab.c"
    default:
        break;
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark -= yym;
#endif
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
        {
            fprintf(stderr, "%s[%d]: after reduction, ", YYDEBUGSTR, yydepth);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
            if (!yytrial)
#endif /* YYBTYACC */
                fprintf(stderr, "result is <%s>, ", YYSTYPE_TOSTRING(yystos[YYFINAL], yyval));
#endif
            fprintf(stderr, "shifting from state 0 to final state %d\n", YYFINAL);
        }
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        *++yystack.p_mark = yyloc;
#endif
        if (yychar < 0)
        {
#if YYBTYACC
            do {
            if (yylvp < yylve)
            {
                /* we're currently re-reading tokens */
                yylval = *yylvp++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylloc = *yylpp++;
#endif
                yychar = *yylexp++;
                break;
            }
            if (yyps->save)
            {
                /* in trial mode; save scanner results for future parse attempts */
                if (yylvp == yylvlim)
                {   /* Enlarge lexical value queue */
                    size_t p = (size_t) (yylvp - yylvals);
                    size_t s = (size_t) (yylvlim - yylvals);

                    s += YYLVQUEUEGROWTH;
                    if ((yylexemes = (YYINT *)realloc(yylexemes, s * sizeof(YYINT))) == NULL)
                        goto yyenomem;
                    if ((yylvals   = (YYSTYPE *)realloc(yylvals, s * sizeof(YYSTYPE))) == NULL)
                        goto yyenomem;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    if ((yylpsns   = (YYLTYPE *)realloc(yylpsns, s * sizeof(YYLTYPE))) == NULL)
                        goto yyenomem;
#endif
                    yylvp   = yylve = yylvals + p;
                    yylvlim = yylvals + s;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    yylpp   = yylpe = yylpsns + p;
                    yylplim = yylpsns + s;
#endif
                    yylexp  = yylexemes + p;
                }
                *yylexp = (YYINT) YYLEX;
                *yylvp++ = yylval;
                yylve++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                *yylpp++ = yylloc;
                yylpe++;
#endif
                yychar = *yylexp++;
                break;
            }
            /* normal operation, no conflict encountered */
#endif /* YYBTYACC */
            yychar = YYLEX;
#if YYBTYACC
            } while (0);
#endif /* YYBTYACC */
            if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
            if (yydebug)
            {
                if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
                fprintf(stderr, "%s[%d]: state %d, reading token %d (%s)\n",
                                YYDEBUGSTR, yydepth, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == YYEOF) goto yyaccept;
        goto yyloop;
    }
    if (((yyn = yygindex[yym]) != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
    {
        fprintf(stderr, "%s[%d]: after reduction, ", YYDEBUGSTR, yydepth);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
        if (!yytrial)
#endif /* YYBTYACC */
            fprintf(stderr, "result is <%s>, ", YYSTYPE_TOSTRING(yystos[yystate], yyval));
#endif
        fprintf(stderr, "shifting from state %d to state %d\n", *yystack.s_mark, yystate);
    }
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    *++yystack.s_mark = (YYINT) yystate;
    *++yystack.l_mark = yyval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    *++yystack.p_mark = yyloc;
#endif
    goto yyloop;
#if YYBTYACC

    /* Reduction declares that this path is valid. Set yypath and do a full parse */
yyvalid:
    if (yypath) YYABORT;
    while (yyps->save)
    {
        YYParseState *save = yyps->save;
        yyps->save = save->save;
        save->save = yypath;
        yypath = save;
    }
#if YYDEBUG
    if (yydebug)
        fprintf(stderr, "%s[%d]: state %d, CONFLICT trial successful, backtracking to state %d, %d tokens\n",
                        YYDEBUGSTR, yydepth, yystate, yypath->state, (int)(yylvp - yylvals - yypath->lexeme));
#endif
    if (yyerrctx)
    {
        yyFreeState(yyerrctx);
        yyerrctx = NULL;
    }
    yylvp          = yylvals + yypath->lexeme;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yylpp          = yylpsns + yypath->lexeme;
#endif
    yylexp         = yylexemes + yypath->lexeme;
    yychar         = YYEMPTY;
    yystack.s_mark = yystack.s_base + (yypath->yystack.s_mark - yypath->yystack.s_base);
    memcpy (yystack.s_base, yypath->yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
    yystack.l_mark = yystack.l_base + (yypath->yystack.l_mark - yypath->yystack.l_base);
    memcpy (yystack.l_base, yypath->yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark = yystack.p_base + (yypath->yystack.p_mark - yypath->yystack.p_base);
    memcpy (yystack.p_base, yypath->yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
    yystate        = yypath->state;
    goto yyloop;
#endif /* YYBTYACC */

yyoverflow:
    YYERROR_CALL("yacc stack overflow");
#if YYBTYACC
    goto yyabort_nomem;
yyenomem:
    YYERROR_CALL("memory exhausted");
yyabort_nomem:
#endif /* YYBTYACC */
    yyresult = 2;
    goto yyreturn;

yyabort:
    yyresult = 1;
    goto yyreturn;

yyaccept:
#if YYBTYACC
    if (yyps->save) goto yyvalid;
#endif /* YYBTYACC */
    yyresult = 0;

yyreturn:
#if defined(YYDESTRUCT_CALL)
    if (yychar != YYEOF && yychar != YYEMPTY)
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        YYDESTRUCT_CALL("cleanup: discarding token", yychar, &yylval, &yylloc);
#else
        YYDESTRUCT_CALL("cleanup: discarding token", yychar, &yylval);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */

    {
        YYSTYPE *pv;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        YYLTYPE *pp;

        for (pv = yystack.l_base, pp = yystack.p_base; pv <= yystack.l_mark; ++pv, ++pp)
             YYDESTRUCT_CALL("cleanup: discarding state",
                             yystos[*(yystack.s_base + (pv - yystack.l_base))], pv, pp);
#else
        for (pv = yystack.l_base; pv <= yystack.l_mark; ++pv)
             YYDESTRUCT_CALL("cleanup: discarding state",
                             yystos[*(yystack.s_base + (pv - yystack.l_base))], pv);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
    }
#endif /* defined(YYDESTRUCT_CALL) */

#if YYBTYACC
    if (yyerrctx)
    {
        yyFreeState(yyerrctx);
        yyerrctx = NULL;
    }
    while (yyps)
    {
        YYParseState *save = yyps;
        yyps = save->save;
        save->save = NULL;
        yyFreeState(save);
    }
    while (yypath)
    {
        YYParseState *save = yypath;
        yypath = save->save;
        save->save = NULL;
        yyFreeState(save);
    }
#endif /* YYBTYACC */
    yyfreestack(&yystack);
    return (yyresult);
}
